{$M 8192,130000,130000}
uses smode256,crt,stmplay,realtime,snow2,snow4;
type
 laga = record
    ofs,seg : word;
    end;

const
 nsn = 1000;
 nsn1 = nsn div 3;
 nsn2 = nsn1 *2;
 sncol=255;

var
 c: char;
 sdevice: byte;
 palette1 : array [0..255,1..3] of byte;
 apage: byte;
 sn : array [1..nsn,1..2] of integer;
 i : integer;
 hier : array [0..319] of integer;
 x: integer;
 yadd : integer;
 ordnum : byte;
 t: longint;
 bseg : word;

 {$F+}
 procedure year_pal; external;
 procedure p1996_pal; external;
 {$L year_pal}
 {$L 1996_pal}
 {$F-}

 function selectsounddevice: byte;
 var
  c: char;
  sel: integer;
  label l1,l2;
 begin
  sel:=0;
  textattr:=7;
  clrscr;
  l1:
  window(28,10,80,25); gotoxy(1,1);
  if sel=0 then textattr:=$70 else textattr:=$7;
  writeln('    PC Speaker (Ugly)     ');
  if sel=1 then textattr:=$70 else textattr:=$7;
  writeln('    Covox LPT1 (Mono)     ');
  if sel=2 then textattr:=$70 else textattr:=$7;
  writeln('    Covox LPT2 (Mono)     ');
  if sel=3 then textattr:=$70 else textattr:=$7;
  writeln(' Covox LPT1+LPT2 (Stereo) ');
  if sel=4 then textattr:=$70 else textattr:=$7;
  writeln('     SB 220h (Mono)       ');
  window(1,1,80,25);
  gotoxy(1,1);
  c:=readkey;
  if c=#13 then goto l2;
  if c='H' then dec(sel);
  if c='P' then inc(sel);
  if sel>4 then sel:=4;
  if sel<0 then sel:=0;
  goto l1;
  l2: selectsounddevice:=sel;
  textattr:=$7;
 end;

 function selectmixingrate: word;
 const
  mixconst : array [0..4] of word =
        (10000,16000,20000,25000,35000);
 var
  c: char;
  sel: integer;
  label l1,l2;
 begin
  sel:=3;
  textattr:=7;
  clrscr;
  l1:
  window(35,10,80,25); gotoxy(1,1);
  if sel=0 then textattr:=$70 else textattr:=$7;
  writeln(' 10000 Hz ');
  if sel=1 then textattr:=$70 else textattr:=$7;
  writeln(' 16000 Hz ');
  if sel=2 then textattr:=$70 else textattr:=$7;
  writeln(' 20000 Hz ');
  if sel=3 then textattr:=$70 else textattr:=$7;
  writeln(' 25000 Hz ');
  if sel=4 then textattr:=$70 else textattr:=$7;
  writeln(' 35000 Hz ');
  window(1,1,80,25);
  gotoxy(1,1);
  c:=readkey;
  if c=#13 then goto l2;
  if c='H' then dec(sel);
  if c='P' then inc(sel);
  if sel>4 then sel:=4;
  if sel<0 then sel:=0;
  goto l1;
  l2: selectmixingrate:=mixconst[sel];
  textattr:=$7;
 end;

procedure hidecursor;
begin
 asm
  mov ah,1
  mov cx,2020h
  int 10h
 end;
end;
 label l1,l2,l3,l4;

begin

 if not readstm('snow.stm') then
   begin
    clrscr;
    writeln('File not found - "snow.stm".');
    writeln;
    halt(1);
   end;

 hidecursor;
 sdevice:=selectsounddevice;
 setup.pspeed:=selectmixingrate;
 ordnum:=5;
 ssetgfxmode;

 bseg:=seg(p1996_pix)+1;

 move(addr(p1996_pix)^,ptr(seg(p1996_pix),16)^,64000);

 fillchar(palette1,768,0);
 setpalette(addr(palette1));

 oldpalette:=addr(palette1);
 newpalette:=addr(p1996_pal);
 maxpalettecounter:=6000;
 palettecounter:=maxpalettecounter;

 scopytoscreen(3,bseg);

 bseg:=seg(year_pix)+1;
 move(addr(year_pix)^,ptr(seg(year_pix),16)^,64000);

 apage:=1;
 for i:=1 to nsn do
    begin
     sn[i,1]:=random(319);
     sn[i,2]:=random(199);
    end;

 playallpatterns(sdevice);

 l2:
  for x:=0 to 319 do hier[x]:=200;

 repeat

  t:=timercounter;

  scopypagetopage(3,apage);

  for i:=1 to nsn do spset(sn[i,1],sn[i,2],sncol,apage);

  ssetvisualpage(apage);
  apage:=(apage+1) and 1;

  for i:=1 to nsn do
    begin
     case i of
      1..nsn1    : yadd:=1;
      nsn1..nsn2 : yadd:=2;
      nsn2..nsn  : yadd:=3;
     end;
     inc(sn[i,1],-2+random(5));
     inc(sn[i,2],yadd);
     x:=sn[i,1];
     if (x<0) or (x>319) then
      begin
       if (sn[i,2]>199) then
        begin
         sn[i,2]:=0;
         sn[i,1]:=random(319);
        end;
       goto l1;
      end;

     if sn[i,2]>=hier[x] then
       begin
        if x<319 then
          begin
           if hier[x+1]>hier[x] then
             begin
              sn[i,1]:=x+1;
              sn[i,2]:=hier[x];
              goto l1;
             end;
          end;
        if x>0 then
          begin
           if hier[x-1]>hier[x] then
             begin
              sn[i,1]:=x-1;
              sn[i,2]:=hier[x]+1;
              goto l1;
             end;
          end;
        spset(x,hier[x],sncol,3);
        sn[i,2]:=0;
        sn[i,1]:=random(319);
        dec(hier[x]);
        if hier[x]<0 then goto l3;
        l4:
       end;
    l1:
    end;

 while timercounter-t<70 do;

 if keypressed then
   begin
    c:=readkey;
    if c=#27 then goto l3;
   end;

 until (getordnum=ordnum) and (ordnum<100);

 fillchar(palette1,768,63);

 oldpalette:=addr(palette1);
 newpalette:=addr(year_pal);
 maxpalettecounter:=1000;
 palettecounter:=maxpalettecounter;

 scopytoscreen(3,bseg);

 ordnum:=100;
 goto l2;

 l3:

 fillchar(palette1,768,0);
 if ordnum=4 then
        oldpalette:=addr(p1996_pal)
             else
        oldpalette:=addr(year_pal);
 newpalette:=addr(palette1);
 maxpalettecounter:=2000;
 palettecounter:=maxpalettecounter;

 while palettecounter>0 do;

 ssettxtmode;
 writeln('by Hax.');
 writeln;

end.